=== doc/man/CMakeLists.txt ===
pod2man (
    ${CMAKE_SOURCE_DIR}/doc/man/tarantool.pod
    "tarantool" 1 doc/man
    "Lua application server and NoSQL database"
)
