=== src/lib/CMakeLists.txt ===
add_subdirectory(bit)
add_subdirectory(bitset)
add_subdirectory(small)
add_subdirectory(salad)
add_library(msgpuck STATIC msgpuck/msgpuck.c)
