=== debian/changelog ===
tarantool (1.6.3.539.g211672f-1) unstable; urgency=medium

  * Init infrastructure for tarantool 1.6.
  * Update debian/copyright:
     + cmake/luatest.cpp
     + third_party/PMurHash.*
     + third_party/lua-yaml/*
     + third_party/sha1.*
     + third_party/open_memstream.*
  * Add lintian-oferrides: libyaml:
    tarantool has patched version of the library.
  * Rename -plugin* package to -module*
  * Conflicts: tarantool 1.5 (it was renamed to tarantool-lts).
  * NOSTRIP /usr/bin/tarantool binary: it uses symbols runtime.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 27 Oct 2014 14:33:07 +0300

tarantool (1.5.3.53.ge2308d8-1) unstable; urgency=medium

  * New Debian snapshot
   + add sophia storage
   + some fixes in box.net.box
   + uses O_DIRECT options to create snapshots
   + update documentation/manpagses
   + memleak in tarantool client

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 19 Feb 2014 18:37:26 +0400
